//--------------------------------------------------------------------
// >>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<<<
//--------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////
////                                                             ////
////  Tests Library                                              ////
////                                                             ////
////                                                             ////
////  Author: Rudolf Usselmann                                   ////
////          rudi@asics.ws                                      ////
////                                                             ////
////                                                             ////
////  Downloaded from: http://www.opencores.org/cores/vga_lcd/   ////
////                                                             ////
/////////////////////////////////////////////////////////////////////
////                                                             ////
//// Copyright (C) 2001 Rudolf Usselmann                         ////
////                    rudi@asics.ws                            ////
////                                                             ////
//// This source file may be used and distributed without        ////
//// restriction provided that this copyright statement is not   ////
//// removed from the file and that any derivative work contains ////
//// the original copyright notice and the associated disclaimer.////
////                                                             ////
////     THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY     ////
//// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   ////
//// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS   ////
//// FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE AUTHOR      ////
//// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,         ////
//// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES    ////
//// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE   ////
//// GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR        ////
//// BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF  ////
//// LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT  ////
//// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  ////
//// OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE         ////
//// POSSIBILITY OF SUCH DAMAGE.                                 ////
////                                                             ////
/////////////////////////////////////////////////////////////////////

//  CVS Log
//
//  $Id: tests.v,v 1.1 2001/08/16 10:01:05 rudi Exp $
//
//  $Date: 2001/08/16 10:01:05 $
//  $Revision: 1.1 $
//  $Author: rudi $
//  $Locker:  $
//  $State: Exp $
//
// Change History:
//               $Log: tests.v,v $
//               Revision 1.1  2001/08/16 10:01:05  rudi
//
//               - Added Test Bench
//               - Added Synthesis scripts for Design Compiler
//               - Fixed minor bug in atahost_top
//
//
//
//
//
//---------------------------------------------------------------------
// Copyright (c) 2010 by Lattice Semiconductor Corporation
//---------------------------------------------------------------------
// Disclaimer:
//
// This VHDL or Verilog source code is intended as a design reference
// which illustrates how these types of functions can be implemented.
// It is the user's responsibility to verify their design for
// consistency and functionality through the use of formal
// verification methods. Lattice Semiconductor provides no warranty
// regarding the use or functionality of this code.
//
// --------------------------------------------------------------------
//
// Lattice Semiconductor Corporation
// 5555 NE Moore Court
// Hillsboro, OR 97214
// U.S.A
//
// TEL: 1-800-Lattice (USA and Canada)
// 503-268-8001 (other locations)
//
// web: http://www.latticesemi.com/
// email: techsupport@latticesemi.com
//
// --------------------------------------------------------------------
// Code Revision History :
// --------------------------------------------------------------------
// Ver: | Author     |Mod. Date |Changes Made:
// V1.0 | Peter.Zhou |06/02/10  |initial release
//
// --------------------------------------------------------------------
`define	CTRL			32'h0000_0000
`define	STAT			32'h0000_0004
`define	PCTR			32'h0000_0008
`define DEVICE0		32'h0000_0014
`define DEVICE1		32'h0000_0018
`define DMA_PORT  32'h0000_003C
`define	ATA_DEV		32'h0000_0040
//--
task show_errors;
begin
		$display("\n");
		$display("     +--------------------+");
		$display("     |  Total ERRORS: %0d   |", error_cnt);
		$display("     +--------------------+");
end
endtask
//--
task reg_test;
reg	[31:0]	data;
reg	[31:0]	pattern;
integer			n;
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** Register Test                                 ***");
		$display("*****************************************************\n");
		show_errors;
		$display("*****************************************************");
		$display("*** Test DONE ...                                 ***");
		$display("*****************************************************\n\n");
end
endtask
//--
task io_test1;
reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
reg	[31:0]	data3;
integer		  n;
integer		  id;
integer		  del;
integer		  del_max;
integer		  iordy_del;
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** IO Test 1                                     ***");
		$display("*** Testing WISHBONE wait state insertion, and    ***");
		$display("*** iordy assertion.                              ***");
		$display("*****************************************************\n");
		id 			= 0;
		del_max = 16;
		for(del = 0;del<del_max;del=del+3)
	 	begin
	 			$display("*** del is %0d\n",del);
	 			for(id=0;id<2;id=id+1)
				begin
						if(!verbose)
						begin
								$display("*** MODE SELECT: 'iordy' enable: %0d, wb-delay: %0d\n", id, del);
						end
						for(iordy_del=0;iordy_del<(id?600: 1);iordy_del=iordy_del+200)
   					begin
								if(verbose)
								begin
										$display("*** MODE SELECT: 'iordy' enable: %0d, wb-delay: %0d iordy_del: %0d\n",id, del, iordy_del);
										a0.iordy_enable = id;
										a0.iordy_delay 	= 600;	// Delay in nS
										a0.init_mem;
										if( id == 1)	data1 = 32'h0000_0082;
										else		data1 = 32'h0000_0090;
										m0.wb_wr1( `CTRL, 4'hf, data1);//write 32'h80 means control ide controller
										m0.wb_rd1( `CTRL, 4'hf, data );
										if(data != data1 )
	   								begin
												$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1,data,$time);
												error_cnt = error_cnt + 1;
												$stop;
	   								end
										m0.wb_rd1(`STAT, 4'hf, data ); //read status register of the ide controller
										//$display(" %h",data);
										//$stop;
										m0.wb_rd1(`PCTR, 4'hf, data ); //read PIO command register of the ide controller
   									repeat(10)	@(posedge clk);
										//Read only Test of ATA registers
										if(verbose)	$display(">>> Running Read Only test 1 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin	   									
												m0.wb_rd1(`ATA_DEV + (n*4),4'hf,data );// reading register from ata device,due to the lowest 2 bit is cut off. so the address need to multply by 4
												$display("data is %d, n+8 is %d",data,n+8); //cs1 is high,so need adding 8
												
												if(data[15:0] != (n+8))
		   									begin
														$display("ERROR: Read 1 Mismatch: Expected: %h Got: %h (%t)",(n+8),data[15:0],$time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
	   								//--
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 1 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_wr1(`ATA_DEV + (n*4),4'hf,{16'd0,~n[15:0]}); 
												repeat(100)	@(posedge clk);
												if(a0.mem[n+8] != ~n[15:0])
		   									begin
														$display("ERROR: Write 1 Mismatch: Expected: %h Got: %h (%t)",~n[15:0], a0.mem[n+8], $time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
	   								//$stop;
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_rd1(`ATA_DEV + (n*4),4'hf,data );
												if(data[15:0] != ~n[15:0] )
		   									begin
														$display("ERROR: Read 2 Mismatch: Expected: %h Got: %h (%t)",~n[15:0],data[15:0],$time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 2 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_wr1(`ATA_DEV + (n*4),4'hf,n);
												m0.wb_rd1(`ATA_DEV + (n*4),4'hf,data);
												if(data[15:0] != n[15:0] )
		   									begin
														$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%t)",n[15:0], data[15:0],$time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
										//Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 3 ... (%t)", $time);
										for(n=0;n<16;n=n+4)
	   								begin
												m0.wb_wr4(`ATA_DEV + (n*4),4'hf,del,{16'h0,~n[13:0],2'h3},{16'h0,~n[13:0],2'h2},{16'h0,~n[13:0],2'h1},{16'h0,~n[13:0],2'h0});
												m0.wb_rd4(`ATA_DEV + (n*4),4'hf,del,data,data1,data2,data3);
												if((data[15:0]!={~n[13:0],2'h3})|(data1[15:0]!={~n[13:0],2'h2})|(data2[15:0]!={~n[13:0],2'h1})|(data3[15:0]!={~n[13:0],2'h0}))
		   									begin
														$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%t)",n[15:0], data[15:0], $time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 4 (RMW) ... (%t)", $time);
										a0.init_mem;
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wr_mem[n]= n[15:0];
												m0.wb_rmw(`ATA_DEV + (n*4),4'hf,del,1,1);
												data 				= m0.rd_mem[n];
												data2[15:0] = n[15:0] + 8;
												data1 			= a0.mem[n+8];
												data3 			= n[15:0];
												if((data[15:0]!= data2[15:0] ) |(data1[15:0] != data3[15:0]))
		   									begin
														$display("ERROR: Read 4a Mismatch: Expected: %h Got: %h (%t)",data2[15:0], data[15:0],$time);
														$display("ERROR: Read 4b Mismatch: Expected: %h Got: %h (%t)",data1[15:0], data3[15:0],$time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
   					    end
   				  end
   			end
    end
		show_errors;
		$display("*****************************************************");
		$display("*** Test DONE ...                                 ***");
		$display("*****************************************************\n\n");
end
endtask
//--
task io_test2;
reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
reg	[31:0]	data3;
integer			n;
integer			id;
integer			del;
integer			del_max;
integer			pio_mode;
integer			iordy_del;
//
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** IO Test 2                                     ***");
		$display("*** Testing PIO Modes, iordy assertion and        ***");
		$display("*** iordy delays.                                 ***");
		$display("*****************************************************\n");
		id 				= 0;
		del 			= 1;
		//verbose 	= 0;
		iordy_del = 0;
		pio_mode	= 4;
		for(pio_mode=0;pio_mode<5;pio_mode=pio_mode+1)
		begin
				for(id=0;id<2;id=id+1)
				begin
						if(!verbose)
						begin
						 		$display("*** MODE SELECT: PIO mode: %0d iordy enable: %0d", pio_mode, id);
						end 		
						for(iordy_del=0;iordy_del < (id ? 600 : 1); iordy_del=iordy_del+200)// from 600 to 1
   					begin
								if(verbose)
								begin
										$display("*** MODE SELECT: PIO mode: %0d, 'iordy' enable: %0d iordy del: %0d\n",pio_mode, id, iordy_del );
										a0.mode 				= pio_mode;
										a0.iordy_enable = id;
										a0.iordy_delay 	= iordy_del;	// Delay in nS
										a0.init_mem;
										data1 = 32'h0000_0001;					//Reset signal
										m0.wb_wr1( `CTRL, 4'hf, data1);
										m0.wb_rd1( `CTRL, 4'hf, data );
										if(data != data1 )
	   								begin
												$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
												error_cnt = error_cnt + 1;
												$stop;
	   								end
//
										data1 = 32'h3000_0400;
										m0.wb_rd1( `STAT, 4'hf, data );									
										if(data != data1 )
 										begin
												$display("ERROR: STAT Register read Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
												error_cnt = error_cnt + 1;
												$stop;
 										end
										case(pio_mode)
	   								  0: data1 = {8'h18, 8'h02, 8'h1c, 8'h04};	// Teoc, T4, T2, T1
	   								  1: data1 = {8'h05, 8'h01, 8'h1c, 8'h02};	// Teoc, T4, T2, T1
	   								  2: data1 = {8'h01, 8'h01, 8'h1c, 8'h00};	// Teoc, T4, T2, T1
	   								  3: data1 = {8'h07, 8'h00, 8'h07, 8'h00};	// Teoc, T4, T2, T1
	   								  4: data1 = {8'h02, 8'h00, 8'h06, 8'h00};	// Teoc, T4, T2, T1
										endcase
										m0.wb_wr1(`PCTR, 4'hf, data1);
										m0.wb_rd1(`PCTR, 4'hf, data );
										if(data != data1 )
	   								begin
												$display("ERROR: PCTR Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
												error_cnt = error_cnt + 1;
												$stop;
	   								end

										if(id==1)begin	data1 = 32'h0000_0082;end
										else begin		data1 = 32'h0000_0080;end
										m0.wb_wr1( `CTRL, 4'hf, data1);
										m0.wb_rd1( `CTRL, 4'hf, data );
										if(data != data1 )
	   								begin
												$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
												error_cnt = error_cnt + 1;
	   								end
   									repeat(10)	@(posedge clk);
										//Read only Test of ATA registers
										if(verbose)	$display(">>> Running Read Only test 1 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_rd1( `ATA_DEV + (n*4) , 4'hf, data );
												if(data[15:0] != (n+8) )
		   									begin
														$display("ERROR: Read 1 Mismatch: Expected: %h Got: %h (%t)",(n+8), data[15:0], $time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 1 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_wr1( `ATA_DEV + (n*4) , 4'hf,{16'd0,~n[15:0]});
												if(a0.mem[n+8] != ~n[15:0] )
		   									begin
														$display("ERROR: Write 1 Mismatch: Expected: %h Got: %h (%t)",~n[15:0], a0.mem[n+8],$time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_rd1( `ATA_DEV + (n*4) , 4'hf, data );
												if(data[15:0] != ~n[15:0] )
		   									begin
														$display("ERROR: Read 2 Mismatch: Expected: %h Got: %h (%t)",~n[15:0], data[15:0], $time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 2 ... (%t)", $time);
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wb_wr1( `ATA_DEV + (n*4) , 4'hf, n );
												m0.wb_rd1( `ATA_DEV + (n*4) , 4'hf, data );
												if(data[15:0] != n[15:0] )
		   									begin
														$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%t)",n[15:0], data[15:0], $time);
														error_cnt = error_cnt + 1;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 3 ... (%t)", $time);
										for(n=0;n<16;n=n+4)
	   								begin
												m0.wb_wr4( `ATA_DEV + (n*4) , 4'hf, del,{16'h0, ~n[13:0], 2'h3},{16'h0, ~n[13:0], 2'h2},{16'h0, ~n[13:0], 2'h1},{16'h0, ~n[13:0], 2'h0});
												m0.wb_rd4( `ATA_DEV + (n*4) , 4'hf, del, data, data1, data2, data3 );
												if(	(data[15:0]  != {~n[13:0], 2'h3}) |
														(data1[15:0] != {~n[13:0], 2'h2}) |
														(data2[15:0] != {~n[13:0], 2'h1}) |
														(data3[15:0] != {~n[13:0], 2'h0}) )
		   									begin
														$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%t)",n[15:0], data[15:0], $time);
														error_cnt = error_cnt + 1;
		   									end
	   								end
										if(verbose)	$display("");
										// Write Then Read Test of ATA registers
										if(verbose)	$display(">>> Running Read/Write test 4 (RMW) ... (%t)", $time);
										a0.init_mem;
										for(n=0;n<16;n=n+1)
	   								begin
												m0.wr_mem[n] = n[15:0];
												m0.wb_rmw( `ATA_DEV + (n*4) , 4'hf, del, 1, 1);
												data = m0.rd_mem[n];
												data2[15:0] =  n[15:0] + 8;
												data1 = a0.mem[n+8];
												data3 = n[15:0];
												if(	(data[15:0]  != data2[15:0] ) |	(data1[15:0] != data3[15:0]) )
		   									begin
														$display("ERROR: Read 4a Mismatch: Expected: %h Got: %h (%t)",data2[15:0], data[15:0], $time);
														$display("ERROR: Read 4b Mismatch: Expected: %h Got: %h (%t)",data1[15:0], data3[15:0], $time);
														error_cnt = error_cnt + 1;
														$stop;
		   									end
	   								end
										if(verbose)	$display("");
								end
						end
				end
    end
		show_errors;
		$display("*****************************************************");
		$display("*** Test DONE ...                                 ***");
		$display("*****************************************************\n\n");
end
endtask
//--
task rst_test;
reg	[31:0]	data;
reg	[31:0]	data1;
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** RST Test                                      ***");
		$display("***                                               ***");
		$display("*****************************************************\n");
		a0.iordy_enable = 0;
		a0.iordy_delay = 0;	// Delay in nS
		a0.init_mem;
		data1 = 32'h0000_0080;
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",	data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
		m0.wb_rd1( `STAT, 4'hf, data );
		m0.wb_rd1( `PCTR, 4'hf, data );
		if(ata_rst_ !== 1'b1)
	  begin
				$display("ERROR: ATA Reset not deasserted ... (%t)", $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
   	repeat(500)	@(posedge clk);
		data1[0] = 1;
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
   	repeat(100)
	  begin
		if(ata_rst_ !== 1'b0)
		begin
			 	$display("ERROR: ATA Reset not asserted ... (%t)", $time);
				error_cnt = error_cnt + 1;
		end

		@(posedge clk);
	  end
//--
		data1[0] = 0;
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
//--
		if(ata_rst_ !== 1'b1)
	  begin
				$display("ERROR: ATA Reset not deasserted ... (%t)", $time);
				error_cnt = error_cnt + 1;
	  		$stop;
	  end
		show_errors;
		$display("*****************************************************");
		$display("*** Test DONE ...                                 ***");
		$display("*****************************************************\n\n");
end
endtask
//---
task int_test;
reg	[31:0]	data;
reg	[31:0]	data1;
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** INT Test                                      ***");
		$display("***                                               ***");
		$display("*****************************************************\n");
		a0.iordy_enable = 0;
		a0.iordy_delay 	= 0;
		a0.init_mem;
		data1 					= 32'h0000_0080;
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1,data,$time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
		// No interrupts at this point
		m0.wb_rd1(`STAT, 4'hf, data );
		data1 = 32'h3000_0400;//This value only mean version control,in this area,the version is 4'h3
		#1;
		if(data !== data1)
	  begin
			 	$display("ERROR: ATA STATUS mismatch (1), Expected: %0h Got: %0h (%t)",  data1, data,$time);
				error_cnt = error_cnt + 1;
	 	end
   	repeat(20)	@(posedge clk);
		// No interrupts at this point
		m0.wb_rd1(`STAT, 4'hf, data );
		data1 = 32'h3000_0400;
		if(data !== data1)
	  begin
				$display("ERROR: ATA STATUS mismatch (2), Expected: %0h Got: %0h (%t)", data1, data, $time);
				error_cnt = error_cnt + 1;
	  end
		// Assert Interrup
		ata_intrq_r = 1;
   	repeat(10)	@(posedge clk);
		ata_intrq_r = 0;
		// Check to see if int bit is set
		m0.wb_rd1( `STAT, 4'hf, data );
		data1 = 32'h3000_0401;
		if(data !== data1)
	  begin
				$display("ERROR: ATA STATUS mismatch (3), Expected: %0h Got: %0h (%t)", data1, data, $time);
				error_cnt = error_cnt + 1;
	  end
   	repeat(10)	@(posedge clk);
		// Make sure it is not cleared after another read
		m0.wb_rd1(`STAT,4'hf,data);
		data1 = 32'h3000_0401;
		if(data !== data1)
	  begin
				$display("ERROR: ATA STATUS mismatch (4), Expected: %0h Got: %0h (%t)", data1, data, $time);
				error_cnt = error_cnt + 1;
	  end

		// Clear interrupt
		data1 = 32'h0000_0000;
		m0.wb_wr1( `STAT, 4'hf, data1 );

		// Should be cleared now ...
		m0.wb_rd1( `STAT, 4'hf, data );
		data1 = 32'h3000_0400;
		if(data !== data1)
	  begin
				$display("ERROR: ATA STATUS mismatch (5), Expected: %0h Got: %0h (%t)", data1, data, $time);
				error_cnt = error_cnt + 1;
	  end

		// Check again ....
		m0.wb_rd1( `STAT, 4'hf, data );
		data1 = 32'h3000_0400;
		if(data !== data1)
	  begin
				$display("ERROR: ATA STATUS mismatch (6), Expected: %0h Got: %0h (%t)", data1, data, $time);
				error_cnt = error_cnt + 1;
	  end
   	repeat(100)	@(posedge clk);
		show_errors;
		$display("*****************************************************");
		$display("*** Test DONE ...                                 ***");
		$display("*****************************************************\n\n");
end
endtask
//*******************
integer i;
task DMA_test;
reg[31:0] data;
reg[31:0] data1;
begin
		$display("\n\n");
		$display("*****************************************************");
		$display("*** DMA Test                                      ***");
		$display("***                                               ***");
		$display("*****************************************************\n");
		//--
		DMA_Ack = 0;
		a0.iordy_enable = 0;
		a0.iordy_delay 	= 0;
		a0.init_mem;
		$display("\n\n");
		$display("*****************************************************");
		$display("*** Look Up the BSY bit of the status of the ATA  ***");
		$display("***          device                               ***");
		$display("*****************************************************\n");
		$display("*** The first step of the Look up the BSY bit********");
		$display("*** Generate reset signal and empty ide_ctrl_en and DMA_ctrl_en ***");
		data1 = 32'h0000_0001;					//Reset signal
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
	  //
	  a0.iordy_enable = 1;
		a0.iordy_delay 	= 600;	// Delay in nS
		a0.init_mem;
		//
		data1 = 32'h0000_0090;
		m0.wb_wr1( `CTRL, 4'hf, data1);//write 32'h90 means control ide controller,Open IDE_ctr enable and ide PP enable 
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1,data,$time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
	  //--
	  m0.wb_rd1(`STAT, 4'hf, data ); //read status register of the ide controller									
		m0.wb_rd1(`PCTR, 4'hf, data ); //read PIO command register of the ide controller
   	repeat(10)	@(posedge clk);
		//Read only Test of ATA registers
		//--
		a0.mem[15] = 16'h0;
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data );

		if( data[7] == 1'b1 )
		begin
				$display("ATA device is busy, The host can not configure the command register,data[7] is %b", data[7]);
				$stop;
		end
		$display("ATA device is not busy, The host can configure the parameter and the command register,status is %h", data);
		
		$display("*** The second step of configure the register of the ATA device********\n");
		
		$display("*** Write feature register ***************\n");
		m0.wb_wr1(`ATA_DEV + (1*4),4'hf,32'h0);
		m0.wb_rd1(`ATA_DEV + (1*4),4'hf,data);
		
		if( data !== 32'h0 )
		begin
				$display("ATA device Write feature register configure failed,data is %h", data);
				$stop;
		end
		
		$display("*** Write Sector Count register ***************\n");
		m0.wb_wr1(`ATA_DEV + (2*4),4'hf,32'h1); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (2*4),4'hf,data);
		if( data !== 32'h1 )
		begin
				$display("ATA device Write Sector Count register configure failed,Sector Count is %h", data);
				$stop;
		end
		
		//--
		$display("*** Write Sector Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (3*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (3*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Sector Number register configure failed,Sector Number is %h", data);
				$stop;
		end
		//
		//--
		$display("*** Write Cylinder Low Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (4*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (4*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Cylinder Low Number register configure failed,Cylinder Low Number Number is %h", data);
				$stop;
		end
		//--
		$display("*** Write Cylinder high Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (5*4),4'hf,32'h0);
		repeat(100) @(posedge clk); 
		m0.wb_rd1(`ATA_DEV + (5*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Cylinder high Number register configure failed,Cylinder high Number Number is %h", data);
				$stop;
		end
		//--
		$display("*** Write Drive and Head register ***************\n");
		m0.wb_wr1(`ATA_DEV + (6*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (6*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Drive and Head register configure failed,Drive and Head is %h", data);
				$stop;
		end
		//--
		$display("*** Write Command register ***************\n");
		m0.wb_wr1(`ATA_DEV + (7*4),4'hf,32'hCA); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data);
		if( data !== 32'hCA )
		begin
				$display("ATA device Write Command register configure failed,Command is %h", data);
				$stop;
		end
		//--
		repeat(100) @(posedge clk);
//--		
		a0.mem[15] = 16'h0;
		dmarq_pad_i = 1'b1;
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data );
		if( data[3] == 1'b1 )
		begin
				$display("ATA device request data transfer failed, it need re-configure the command %h ", data);
				$stop;
		end
		$display("ATA device can identfy the input command, the status is %h", data);
		//
		$display("*** The third step is configure ide controller DMA register ********\n");
//--		
		repeat(100) @(posedge clk);
//--
		data1= 32'h15001504;
		m0.wb_wr1( `DEVICE0, 4'hf, data1);
		m0.wb_rd1( `DEVICE0, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end	
	  //
		data1= 32'h15001504;
		m0.wb_wr1( `DEVICE1, 4'hf, data1);
		m0.wb_rd1( `DEVICE1, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end	
//--
		data1 = 32'h0000_A000;					//DMA control
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end	
	 	data1 = 32'h0000_0001;
	 	DMA_Ack = 0;
	 	@(posedge clk);
	  for ( i =0; i<= 127; i= i+1)
	  begin	  		
	  		if(DMA_req)
	  		begin	  							
	  				m0.wb_wr1(`DMA_PORT, 4'hf, data1);
	  				DMA_Ack = 1'b1; 
	  				@(posedge ata_diow_);
	  				DMA_Ack =#220 1'b0;
	  				data1[15:0] = data1[15:0]+ 2'd2;
	  				data1[31:16] = data1[31:16]+ 2'd2;
	  				//--
	  				m0.wb_rd1(`STAT, 4'hf, data );
	  				
	  				while( data[9] == 1'b1)
	  				begin
	  						m0.wb_rd1(`STAT, 4'hf, data );
	  				end	
	  				wait(DMA_req);
	  		end
	  		else
	  		begin
	  				//DMA_Ack = 1'b0;
	  		end
	  end	  
	  //--
	  repeat(100) @(posedge clk);
	  
	  $display("\n\n");
		$display("*****************************************************");
		$display("*** Look Up the BSY bit of the status of the ATA  ***");
		$display("***          device                               ***");
		$display("*****************************************************\n");
		$display("*** The first step of the Look up the BSY bit********");
		$display("*** Generate reset signal and empty ide_ctrl_en and DMA_ctrl_en ***");
		data1 = 32'h0000_0001;					//Reset signal
		m0.wb_wr1( `CTRL, 4'hf, data1);
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
	  //
	  a0.iordy_enable = 1;
		a0.iordy_delay 	= 600;	// Delay in nS
		a0.init_mem;
		//
		data1 = 32'h0000_0090;
		m0.wb_wr1( `CTRL, 4'hf, data1);//write 32'h90 means control ide controller,Open IDE_ctr enable and ide PP enable 
		m0.wb_rd1( `CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1,data,$time);
				error_cnt = error_cnt + 1;
				$stop;
	  end
	  //--
	  m0.wb_rd1(`STAT, 4'hf, data ); //read status register of the ide controller									
		m0.wb_rd1(`PCTR, 4'hf, data ); //read PIO command register of the ide controller
   	repeat(10)	@(posedge clk);
		//Read only Test of ATA registers
		//--
		a0.mem[15] = 16'h0;
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data );
		if( data[7] == 1'b1 )
		begin
				$display("ATA device is busy, The host can not configure the command register,data[7] is %b", data[7]);
				$stop;
		end
		$display("ATA device is not busy, The host can configure the parameter and the command register,status is %h", data);
		
		$display("*** The second step of configure the register of the ATA device********\n");
		
		$display("*** Write feature register ***************\n");
		m0.wb_wr1(`ATA_DEV + (1*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (1*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write feature register configure failed,data is %h", data);
				$stop;
		end
		
		$display("*** Write Sector Count register ***************\n");
		m0.wb_wr1(`ATA_DEV + (2*4),4'hf,32'h1); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (2*4),4'hf,data);
		if( data !== 32'h1 )
		begin
				$display("ATA device Write Sector Count register configure failed,Sector Count is %h", data);
				$stop;
		end
		
		//--
		$display("*** Write Sector Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (3*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (3*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Sector Number register configure failed,Sector Number is %h", data);
				$stop;
		end
		//
		//--
		$display("*** Write Cylinder Low Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (4*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (4*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Cylinder Low Number register configure failed,Cylinder Low Number Number is %h", data);
				$stop;
		end
		//--
		$display("*** Write Cylinder high Number register ***************\n");
		m0.wb_wr1(`ATA_DEV + (5*4),4'hf,32'h0);
		repeat(100) @(posedge clk); 
		m0.wb_rd1(`ATA_DEV + (5*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Cylinder high Number register configure failed,Cylinder high Number Number is %h", data);
				$stop;
		end
		//--
		$display("*** Write Drive and Head register ***************\n");
		m0.wb_wr1(`ATA_DEV + (6*4),4'hf,32'h0); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (6*4),4'hf,data);
		if( data !== 32'h0 )
		begin
				$display("ATA device Write Drive and Head register configure failed,Drive and Head is %h", data);
				$stop;
		end
		//--
		$display("*** Write Command register ***************\n");
		m0.wb_wr1(`ATA_DEV + (7*4),4'hf,32'hC8); 
		repeat(100) @(posedge clk);
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data);
		if( data !== 32'hC8 )
		begin
				$display("ATA device Write Command register configure failed,Command is %h", data);
				$stop;
		end
		//--
		repeat(100) @(posedge clk);
//--		
		a0.mem[15] = 16'h0;
		dmarq_pad_i = 1'b1;
		m0.wb_rd1(`ATA_DEV + (7*4),4'hf,data );
		if( data[3] == 1'b1 )
		begin
				$display("ATA device request data transfer failed, it need re-configure the command %h", data);
				$stop;
		end
		$display("ATA device can identfy the input command, the status is %h", data);
	  
	  
	  //--
		data1 = 32'h0000_8000;					//DMA Control
		m0.wb_wr1(`CTRL, 4'hf, data1);
		m0.wb_rd1(`CTRL, 4'hf, data );
		if(data != data1 )
	  begin
				$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%t)",data1, data, $time);
				error_cnt = error_cnt + 1;
				$stop;
	  end	
	 	data1 = 32'h0000_0001;
	 	DMA_Ack = 0;
	 	i =0;
	 	$display("%d",i);
	 	@(posedge clk);
	  for ( i =0; i<= 128; i= i+1)
	  begin	  		
	  		$display("%d",i);
	  		if(DMA_req)
	  		begin	  			
	  				//--
	  				$display("%d",i); 
	  				DMA_Ack = 1;
	  				m0.wb_rd1(`DMA_PORT, 4'hf, data);	  					
	  				@(posedge ata_dior_);
	  				DMA_Ack =#220 0;
	  				//while( data[10] == 1'b0)
	  				//begin
	  				//		m0.wb_rd1(`STAT, 4'hf, data );
	  				//			@ (posedge clk);
	  				//end	
	  				//DMA_Ack = 0;
	  				//--
	  				@ (posedge clk);
	  				wait(DMA_req);
	  		end
	  		else
	  		begin	  				
	  				wait(DMA_req);
	  				
	  		end
	  end	  
	  
	  repeat(100) @(posedge clk);
	  DMA_Ack = 1'b0;
	  dmarq_pad_i = 1'b0;
	  repeat(100) @(posedge clk);
	  $display("Write DMA is ended %t",$time);
end 
endtask
    
    